; FPSP_VER_ASM
; on H38 as 'ver_asm'
; 14th September 1998
;
          DATA      100
RED       EQU       2
H_VER     EQU       12        position of version/ident
IDENT     EQU       'gw'
;
          BRA.S     START
          DS.L      1
          DC.W      $4AFB
          DC.W      N_END-NAME
NAME      DC.B      "FPSP_VER V1.4 September 1998"
N_END     DS.B      0
;
START     LEA       SCR,A1
          MOVEA.W   UT_SCR,A2
          JSR       (A2)
          LEA       IDS,A2
          MOVE.L    A0,(A2)
          MOVEQ     #RED,D1
          MOVEQ     #-1,D3    timeout
          BSR       INK
          LEA       NAME-2,A1
          BSR       UMT
          MOVEQ     #0,D1
          BSR       INK
          MOVEQ     #10,D1
          MOVEQ     #IO_SBYTE,D0
          TRAP      #3
          MOVEA.L   A7,A6
          MOVE.W    (A6)+,D0            number of channels (ignored)
          LEA       (A6,D0.W*4),A6      -> string
          TST.W     (A6)                is there a string? . .
          BEQ       HELP                . . no
          MOVEA.L   A6,A0
          MOVEQ     #1,D3               OPEN_IN
          MOVEQ     #-1,D1              this job
          MOVEQ     #IO_OPEN,D0
          TRAP      #2
          TST.L     D0
          BNE       ERROR1    ---->
;
; Check that TYPE is 1
;
	BSR	TYPE
	BNE	ERROR3	---->
          LEA       -4(A7),A7           get space for a buffer
          MOVEA.L   A7,A5
          MOVEQ     #H_VER,D1              position
          MOVEQ     #-1,D3              timeout
          MOVEQ     #FS_POSAB,D0
          TRAP      #3
          TST.L     D0
          BNE       ERROR2    ---->
          MOVEQ     #4,D2               get 4 bytes . .
          MOVEA.L   A5,A1               . . to buffer
          MOVEQ     #IO_FSTRG,D0
          TRAP      #3
          TST.L     D0
          BNE       ERROR2    ---->
;
; check ident
;
          CMPI.W    #IDENT,2(A5)
          BNE       ERROR2    ---->
          MOVEA.L   A6,A1               filename
          BSR       UMT                 print it
          MOVE.W    (A5),D0   version a.b
          LEA       H1D,A2
          BSR       PUT_V
          LEA       H1,A1
END1      BSR       UMT
END       MOVEQ     #-1,D1
          MOVE.W    #300,D3
          SUBA.L    A1,A1
          MOVEQ     #MT_SUSJB,D0
          TRAP      #1
          MOVEQ     #0,D3               no errors
          MOVEQ     #MT_FRJOB,D0
          TRAP      #1
;
HELP      LEA       H2,A1
          BRA       END1
;
ERROR1    LEA       H3,A1
          BRA       END1
;
ERROR2    LEA       H4,A1
          BRA       END1
;
ERROR3	LEA	H5,A1
	BRA	END1
;
ERROR4	LEA	H6,A1
	BRA	END1
;
UMT       MOVEA.L   IDS,A0
          MOVEA.W   UT_MTEXT,A2
          JMP       (A2)
;
INK       MOVEQ     #SD_SETIN,D0
          TRAP      #3
          RTS
;
; D0.W contains 'a' and 'b' in its two bytes.
;
PUT_V     MOVE.W    D0,D2
          BFEXTU    D2{16:8},D0         D0.L has 'a'
          MOVEA.L   A2,A0
          BSR       LTOD                (leaves D0.L = 0)
          LINK      A4,#-16             space to get 'b'
          MOVEA.L   A4,A0               end of space
          MOVE.B    D2,D0               'b' is in D0.L
          BSR       LTOD
          ADDQ      #1,A2
          MOVE.L    A4,D1
          SUB.L     A0,D1               length of 'b'
          ANDI.W    #3,D1               (an unnecessary belt & braces!?)
          BRA       PUT_V1
PUT_V2    MOVE.B    (A0)+,(A2)+
PUT_V1    DBF       D1,PUT_V2
          UNLK      A4
          RTS
;
; LTOD sets ASCII decimal for D0.L in
; a buffer indicated by A0 (and uses D1).
;
; At entry:
;   D0.L contains the (positive) number.
;   A0 points to the end of the area to
;   contain the ASCII decimal.
;
; At exit:
;   D0 = 0
;   A0 points to the start of the number.
;
LTOD      SWAP      D0
          BEQ.S     LTODW2
          MOVE.W    D0,D1
          BEQ.S     LTODW
          EXT.L     D1
          DIVU      #10,D1
          SWAP      D1
          MOVE.W    D1,D0
          SWAP      D0
          DIVU      #10,D0
          SWAP      D0
          ADDI.W    #48,D0
          MOVE.B    D0,-(A0)
          SWAP      D0
          MOVE.W    D0,D1
          MOVE.L    D1,D0
          BRA.S     LTOD
LTODW1    DIVU      #10,D0
          SWAP      D0
LTODW2    ADDI.W    #48,D0
          MOVE.B    D0,-(A0)
          CLR.W     D0
LTODW     SWAP      D0
          BNE.S     LTODW1
          RTS
;
; Condition code Z is set if the file type is 1
;
TYR	REG	D0-3/A1
;
TYPE	MOVEM.L	TYR,-(A7)		keep regs
	LEA	-64(A7),A7	keep space for header
	MOVEQ	#64,D2
	MOVEQ	#-1,D3
	MOVEA.L	A7,A1
	MOVEQ	#FS_HEADR,D0
	TRAP	#3
	TST.L	D0
	BNE	TYPE_ER	---->
	CMPI.B	#1,5(A7)
	LEA	64(A7),A7	restore A7
	MOVEM.L	(A7)+,TYR
	RTS
;
TYPE_ER	LEA	64(A7),A7
	MOVEM.L	(A7)+,TYR
	BRA	ERROR4	---->
;
H1        DC.W      H1E-H1-2
          DC.B      10,'is version     '
H1D       DC.B      '.   '
H1E       DS.B      0
;
H2        DC.W      H2E-H2-2
          DC.B      'EX FPSP_VER_BIN;" <filename> "',10
          DC.B      'gives the version number of <filename>'
H2E       DS.B      0
;
H3        DC.W      H3E-H3-2
          DC.B      10,"Can't open file"
H3E       DS.B      0
;
H4        DC.W      H4E-H4-2
          DC.B      10,'Not an FPSP'
H4E       DS.B      0
;
H5	DC.W	H5E-H5-2
	DC.B	10,'Not file type 1'
H5E	DS.B	0
;
H6	DC.W	H6E-H6-2
	DC.B	10,"Can't open header"
H6E	DS.B	0
          DS.W      0
;
SCR       DC.B      211,2,7,0
          DC.W      40*6+8,40,100,100
IDS       DS.L      1
